/*
 * dom_parser.c
 *
 *  Created on: Feb 25, 2009
 *      Author: david.niemoller
 */
#include <libxml/xmlreader.h>

void parseDoc(char *docname);
void processNode(xmlTextReaderPtr reader);

/*
int main(int argc, char **argv)
{
    printf("Testing\n");

    char *docname;

    if (argc <= 1)
    {
            printf("Usage: %s docname\n", argv[0]);
            return(0);
    }

    docname = argv[1];
    parseDoc (docname);

    return (1);
}
*/

void parseDoc(char *docname)
{
    xmlTextReaderPtr reader;
    xmlDocPtr doc;
    xmlNodePtr cur;
    xmlNode *node;
    int ret;
    doc = xmlParseFile(docname);
    reader = xmlNewTextReaderFilename(docname);
    //printf("%d\n",ret);
    if (reader != NULL)
    {
        ret = xmlTextReaderRead(reader);
        while(ret == 1)
        {
            processNode(reader);
            ret = xmlTextReaderRead(reader);
        }
    }
}

int _indent = 0, _depth = 0;

void processNode(xmlTextReaderPtr reader) {

	char indentation[]
	= "                                                                                     "
	  "                                                                                     \0";
	indentation[_indent] = 0;
	switch(xmlTextReaderNodeType(reader))
    {
		case XML_READER_TYPE_NONE:
		case XML_READER_TYPE_ATTRIBUTE:
		case XML_READER_TYPE_TEXT:
		case XML_READER_TYPE_CDATA:
		case XML_READER_TYPE_ENTITY_REFERENCE:
		case XML_READER_TYPE_ENTITY:
		case XML_READER_TYPE_PROCESSING_INSTRUCTION:
		case XML_READER_TYPE_COMMENT:
		case XML_READER_TYPE_DOCUMENT:
		case XML_READER_TYPE_DOCUMENT_TYPE:
		case XML_READER_TYPE_DOCUMENT_FRAGMENT:
		case XML_READER_TYPE_NOTATION:
		case XML_READER_TYPE_END_ENTITY:
		case XML_READER_TYPE_XML_DECLARATION:{
			int depth = xmlTextReaderDepth(reader);
			printf("ZOWIE %d %s XML_READER_TYPE = %d\n",depth,indentation,xmlTextReaderNodeType(reader));
		}break;

		case XML_READER_TYPE_WHITESPACE:
		case XML_READER_TYPE_SIGNIFICANT_WHITESPACE:/*NOOP*/break;

		case XML_READER_TYPE_ELEMENT:{
			xmlChar* name = xmlTextReaderName(reader);
			int depth = xmlTextReaderDepth(reader);
			indentation[_indent]= ' ';
			_indent = depth*5;
			_depth  = depth;
			indentation[_indent] = 0;
			printf("ZOWIE %d %s<%s>\n",depth,indentation,name);
			if(depth==0){
				xmlChar* namespace = xmlTextReaderNamespaceUri(reader);
				printf("     STARTING DOCUMENT <%s:%s>\n", namespace, name);
			}
		};break;

		case XML_READER_TYPE_END_ELEMENT:{
			int depth = _depth = xmlTextReaderDepth(reader);
			_indent = depth*5;
			indentation[_indent] = 0;
			xmlChar* name = xmlTextReaderName(reader);
			printf("ZOWIE %d %s</%s>\n",depth,indentation,name);
		};break;
    };
}
